# For Rails Beginner

給 Ruby on Rails 入門初學者，或是正要開始學習的朋友。


## 行前建議

1. 一台可以上網的電腦
2. 不怕閱讀英文
3. 一顆愉悅的心


## 學習資源

學習 Rails 開發，大致上會分成三個部分

1. 基本網站知識 HTML & CSS
2. 開發工具使用 git/command line
3. 著手 Ruby on Rails

註：標題若為全英文即該教材為英文授課，順序是我認為對於新手的難易度。


## 完整教學課程

這邊收錄完整的教學課程，幾乎都是從基礎教起到可實作出簡單的網站。

### 文章

標籤|名稱|
--- | ---
![][All/Free] | [為你自己學 Ruby on Rails](http://railsbook.tw/)
![][All/Free] | [Ruby on Rails 實戰聖經](https://ihower.tw/rails4/)
![][All/Free] | [Rails Guides](http://guides.rubyonrails.org/)

### 互動教學或是影片教學

標籤|名稱|
--- | ---
![][Pay by/Course] | [為你自己把程式學好](https://iamcoding.tw/)
![][Online/Free] | [RailsFun 教學與分享](https://www.youtube.com/playlist?list=PLJ6M-k9dQEQ3VsyOZQwjZ5GdjaLJH3eB_)
![][Online/Free] | [Ruby on Rails Tutorial](https://www.railstutorial.org/)
![][Online/Free] | [UPCASE by Thoughtbot](https://thoughtbot.com/upcase)
![][Online/Free] | [Learn Rails by codecademy](https://www.codecademy.com/learn/learn-rails)

### 實體課程

標籤|名稱|
--- | ---
![][Pay by/Course] | [Ruby on Rails 從零開始 by 五倍紅寶石](https://5xruby.tw/talks?category=ruby-on-rails)


## 各別項目課程

教材各項目擇一學習即可，此部分為建構基本網頁知識

### 網站基本架構

標籤|名稱|
--- | ---
![][All/Free] | [CodeCademy—Learn html](https://www.codecademy.com/learn/learn-html)
![][All/Free] | [Code Guide by @mdo](http://mdo.github.io/code-guide/)
![][All/Free] | [MDN──給開發者的網頁技術文件](https://developer.mozilla.org/zh-TW/docs/Web)

### Command Line

標籤|名稱|
--- | ---
![][Online/Free] | [Learn Enough Command Line to Be Dangerous](http://www.learnenough.com/command-line-tutorial)

### Git 使用

標籤|名稱|
--- | ---
![][All/Free] | [為你自己學 Git](https://gitbook.tw/)
![][All/Free] | [連猴子都能懂得 Git 入門指南](https://backlogtool.com/git-guide/tw/)
![][All/Free] | [Git 官方教材](http://git-scm.com/book/zh/ch1-4.html)
![][All/Free] | [Learn Git Branching](https://learngitbranching.js.org/)

### Ruby 語言

標籤|名稱|
--- | ---
![][All/Free] | [笨方法學 Ruby](http://lrthw.github.io/)
![][All/Free] | [Ruby Document](http://ruby-doc.org)
![][All/Free] | [Ruby 語言官方網站](https://www.ruby-lang.org/zh_tw/)

### 其他

標籤|名稱|
--- | ---
![][All/Free] | [使用 Ruby on Rails 開發一款網頁遊戲](https://www.youtube.com/playlist?list=PLnY6meQl8ifGFjqrU5Q1no5fGi-_u0abG)
![][All/Free] | [Codewars](http://www.codewars.com/)


## 學習心得

### 講座
  - 高見龍──[我寫了 10 年的 Ruby，然後呢](https://coscup.org/2018/programs/10-year-ruby/)（[影片](https://www.youtube.com/watch?v=UJ7ZkX6yiJM)）

### 部落格
  - [蒼時弦也](https://blog.aotoki.me/)

### 文章
  - [[問題] RUBY在台灣還有市場嗎？](https://www.ptt.cc/bbs/Ruby/M.1531982229.A.9E9.html)
  - Huli──[每一篇心得都有價值——為什麼初學者才更應該要寫心得筆記](https://medium.com/hulis-blog/why-blogging-ab77fd8c6ffa)
  - Kevin──[Ruby on Rails 新手自學的各種血淚與經驗分享](https://devs.tw/post/168)
  - Annideas──[我的Ruby學習之路](http://annideas.tw/2016/10/04/my-ruby-life/)
  - 攝理生活記──[Ruby on Rails 自學推薦資源以及注意事項](http://blog.cgmlife.net/posts/2014/04/12/recommended-ruby-on-rails-learning-resources)
  - 內容先決──[新手寫給新手的 Ruby on Rails 介紹](http://disco26.logdown.com/posts/168410-novice-to-novice-ruby-on-rails-introduction)
  - Azraeil──[我的 Ruby on Rails 400 小時自我學習心得紀錄](https://web.archive.org/web/20191126133646/https://medium.com/@Izraeill/%E5%88%86%E4%BA%AB-%E6%88%91%E7%9A%84-ruby-on-rails-400-%E5%B0%8F%E6%99%82%E8%87%AA%E6%88%91%E5%AD%B8%E7%BF%92%E5%BF%83%E5%BE%97%E7%B4%80%E9%8C%84-c6821e801f1b)

### 鐵人賽 30 天挑戰
  - Vita Ora──[Junior Ruby on Rails 工程師的心得與自我挑戰 30 天](https://ithelp.ithome.com.tw/users/20112656/ironman/2205)
  - River──[自我挑戰 Ruby 刷題 30 天](https://ithelp.ithome.com.tw/users/20061211/ironman/2674)
  - 行天宮安東尼──[Rails guide / Ruby API study](https://ithelp.ithome.com.tw/users/20120742/ironman/2631)
  - CJ-Han──[鐵人賽](https://cjhan.tw/posts/ithome-day0-introduction)
  - Annideas──[Ruby女孩：10萬.times { puts "為什麼？" }](https://ithelp.ithome.com.tw/users/20091352/ironman/811)
 
## 有問題、找導師、找戰友、找工作

### 有問題
  - [提問的智慧](https://github.com/ryanhanwu/How-To-Ask-Questions-The-Smart-Way)
  - 嘗試 Google 錯誤訊息
  - 找找 [Stack Overflow](http://stackoverflow.com/)
  - [Ruby Taiwan AMA (Ask Me Anything)](https://github.com/rubytaiwan/AMA)
  - [Facebook—Ruby on Rails 新手村](https://www.facebook.com/groups/RailsRookie/)
  - [Ruby China 論壇](https://ruby-china.org/)

### 找導師、找戰友、找工作
  - [台灣使用 Ruby 的公司列表](https://github.com/rubytaiwan/AMA/wiki/Companies)
  - [Ruby 默默會 - 工作職缺看版](https://github.com/5xRuby/mokumokukai)
  - [Ruby Taiwan 職缺看板](http://jobs.ruby.tw/)

### 面試心得
  - Ting Ting──[30天修煉Ruby面試精選30題](https://ithelp.ithome.com.tw/users/20111177/ironman/1613)
  - 李威辰──[菜鳥Rails工作面試初體驗](https://medium.com/@eggyy1224/%E8%8F%9C%E9%B3%A5rails%E5%B7%A5%E4%BD%9C%E9%9D%A2%E8%A9%A6%E5%88%9D%E9%AB%94%E9%A9%97-a562cc700133)
  - Nathan Lee──[Jr. Ruby on Rails Engineer面試初體驗（上）：事前準備 & 技術面試](https://medium.com/change-or-die/jr-rails-on-rails-engineer%E9%9D%A2%E8%A9%A6%E5%88%9D%E9%AB%94%E9%A9%97-%E4%B8%8A-%E4%BA%8B%E5%89%8D%E6%BA%96%E5%82%99-%E6%8A%80%E8%A1%93%E9%9D%A2%E8%A9%A6-8a471f107c15)
  - alanyeh (小強)──[Rails面試分享](https://www.ptt.cc/bbs/Soft_Job/M.1460708204.A.FF5.html)
  - Bruce 的玩具間──[應徵 Rails 工作的心得](http://toyroom.bruceli.net/tw/2014/02/26/my-experience-on-applying-rails-jobs.html)
  - brucehsu (布魯斯)──[[心得] 後端/全端 工程師 面試心得](https://www.ptt.cc/bbs/Soft_Job/M.1451756899.A.CC2.html)
  - Fred Hung──[轉職 Web 工程師 — 公務員還俗記](https://medium.com/alpha-camp-%E5%8F%B0%E7%81%A3/%E8%BD%89%E8%81%B7-web-%E5%B7%A5%E7%A8%8B%E5%B8%AB-%E5%85%AC%E5%8B%99%E5%93%A1%E9%82%84%E4%BF%97%E8%A8%98-c4d8389e944a)
  - Nic──[一個新鮮人找尋Rails工作的面試經驗](https://blog.niclin.tw/2016/01/07/%E4%B8%80%E5%80%8B%E6%96%B0%E9%AE%AE%E4%BA%BA%E6%89%BE%E5%B0%8Brails%E5%B7%A5%E4%BD%9C%E7%9A%84%E9%9D%A2%E8%A9%A6%E7%B6%93%E9%A9%97/)
  - Nic──[我的中高階 Rails 工作面試心得分享](https://blog.niclin.tw/2019/04/29/%E6%88%91%E7%9A%84%E4%B8%AD%E9%AB%98%E9%9A%8E-rails-%E5%B7%A5%E4%BD%9C%E9%9D%A2%E8%A9%A6%E5%BF%83%E5%BE%97%E5%88%86%E4%BA%AB/)

### 台灣 Ruby 社群聚會表
Title | Website | Facebook | Time & Location |
----- | ------- | -------- | ---------------
Ruby 默默會 | N/A | [rubymokumokukai](https://www.facebook.com/rubymokumokukai/) | 每週二 19:00pm，五倍紅寶石出礦坑
Ruby on Rails 新手村 | N/A | [RailsRookie](https://www.facebook.com/groups/RailsRookie/) | 已併入 Ruby 默默會
Rails Girls Taiwan | [Rails Girls Taiwan](http://railsgirls.tw/) | [railsgirlstw](https://www.facebook.com/railsgirlstw) | 不定期週二晚上，五倍紅寶石出礦坑
Rails Taiwan Meetup | [Rails Taiwan Meetup](http://www.meetup.com/rails-taiwan) | [railstaiwan](https://www.facebook.com/railstaiwan) | 每週二 19：30，Deroot 休閒空間
高雄 Rails Meetup | [Rails Taiwan Meetup](http://www.meetup.com/rails-taiwan) | [Kaohsiung Rails Meetup x 讀書會](https://www.facebook.com/groups/569223303140308)| 每週三 19:00，凹子底站旁 Eagle Cafe
桃園 Ruby on Rails 讀書會 | N/A | [桃園 Ruby on Rails 讀書會](https://www.facebook.com/groups/tyror/) | 暫停
Ruby Taiwan | [Ruby Taiwan](https://ruby.tw) | [RubyTaiwan](https://www.facebook.com/groups/142197385837507/) | N/A
RORTaichung | N/A | [Ruby on Rails 臺中練功房](https://www.facebook.com/groups/RORTaichung/) | 每週四 18：30，曉明摩斯


[All/Free]: https://img.shields.io/badge/All-Free-green.svg?style=flat-square "All Free"
[Online/Free]: https://img.shields.io/badge/Online-Free-green.svg?style=flat-square "Online Free"
[Part of/Free]: https://img.shields.io/badge/Part_of-Free-green.svg?style=flat-square "Part of Free"
[Pay by/Course]: https://img.shields.io/badge/Pay_by-Course-red.svg?style=flat-square "Pay by Course"
